kan-extensions-5.0.2: Kan extensions, Kan lifts, various forms of the Yoneda lemma, and (co)density (co)monads

Copyright | (C) 2013-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | GADTs, TFs, MPTCs
Safe Haskell | Trustworthy
Language | Haskell98

Data.Functor.Contravariant.Coyoneda

Description

The co-Yoneda lemma for presheafs states that `f` is naturally isomorphic to ``Coyoneda` f`.

Synopsis

- data Coyoneda f a where
  - Coyoneda :: (a -> b) -> f b -> Coyoneda f a
- liftCoyoneda :: f a -> Coyoneda f a
- lowerCoyoneda :: Contravariant f => Coyoneda f a -> f a

# Documentation

data Coyoneda f a where #

A `Contravariant` functor (aka presheaf) suitable for Yoneda reduction.

http://ncatlab.org/nlab/show/Yoneda+reduction

Constructors

Coyoneda :: (a -> b) -> f b -> Coyoneda f a |

Instances

Contravariant (Coyoneda f) # |
Methods contramap :: (a -> b) -> Coyoneda f b -> Coyoneda f a # (>$) :: b -> Coyoneda f b -> Coyoneda f a #
Representable f => Representable (Coyoneda f) # |
Associated Types type Rep (Coyoneda f :: * -> *) :: * # Methods tabulate :: (a -> Rep (Coyoneda f)) -> Coyoneda f a # index :: Coyoneda f a -> a -> Rep (Coyoneda f) # contramapWithRep :: (b -> Either a (Rep (Coyoneda f))) -> Coyoneda f a -> Coyoneda f b #
Adjunction f g => Adjunction (Coyoneda f) (Coyoneda g) # |
Methods unit :: a -> Coyoneda g (Coyoneda f a) # counit :: a -> Coyoneda f (Coyoneda g a) # leftAdjunct :: (b -> Coyoneda f a) -> a -> Coyoneda g b # rightAdjunct :: (a -> Coyoneda g b) -> b -> Coyoneda f a #
type Rep (Coyoneda f) # |
type Rep (Coyoneda f) = Rep f

liftCoyoneda :: f a -> Coyoneda f a #

Coyoneda "expansion" of a presheaf

    liftCoyoneda . lowerCoyoneda ≡ id
    lowerCoyoneda . liftCoyoneda ≡ id

lowerCoyoneda :: Contravariant f => Coyoneda f a -> f a #

Coyoneda reduction on a presheaf